from locals import *

class CreatureType:

    def __init__(self, name, id, attack, speed, range, build_time, toupgrade,
                 upgrade, special):
        self.name = name
        self.id = id
        self.attack = attack
        self.speed = speed
        self.range = range
        self.build_time = build_time
        self.toupgrade = toupgrade
        self.upgrade = upgrade
        self.special = special
        self.image_unborn = IUNBORN[self.id]
        self.image_nest = INEST[self.id]

    def get_text_attack(self):
        if self.attack == 0:
            return 'None'
        elif self.attack == 1:
            return 'Weak'
        elif self.attack == 2:
            return 'Average'
        elif self.attack == 3:
            return 'Strong'
        elif self.attack == 4:
            return 'Very Strong'
        elif self.attack == 5:
            return 'Powerful'
        return 'None'
    
    def get_text_speed(self):
        if self.speed == 0:
            return 'Immobile'
        elif self.speed == 1:
            return 'Slow'
        elif self.speed == 2:
            return 'Average'
        elif self.speed == 3:
            return 'Fast'
        elif self.speed == 4:
            return 'Very Fast'
        elif self.speed ==5:
            return 'Super Fast'
        return 'None'
    
    def get_text_range(self):
        if self.range == 0:
            return 'No range'
        elif self.range == 1:
            return 'Short'
        elif self.range == 2:
            return 'Average'
        elif self.range == 3:
            return 'Long'
        elif self.range == 4:
            return 'Very Long'
        elif self.range == 5:
            return 'Sniper'
        return 'None'

    def get_text_special(self):
        if self.special == 'area':
            return 'Area attack'
        elif self.special == 'poison':
            return 'Poison (plus damage, 3/4 speed)'
        elif self.special == 'distract':
            return 'Distraction (3/4 speed)'
        elif self.special == 'distractmore':
            return 'Distraction (1/2 speed)'
        elif self.special == 'fear':
            return 'Fear'
        return 'None'

    def get_description(self):
        text = 'Attack: ' + self.get_text_attack()
        text += ' / Speed: ' + self.get_text_speed()
        text += ' / Range: ' + self.get_text_range()
        text += ' / Special: ' + self.get_text_special()
        return text
    
shadow_crow = CreatureType('Shadow crow', 0, 1, 3, 3, BTIME1, None, None,
                           None)
crow = CreatureType('Crow', 0, 1, 2, 2, BTIME1, UPGRADE1, shadow_crow,
                    None)

roc = CreatureType('Roc', 1, 3, 3, 5, BTIME2, None, None, None)
hawk = CreatureType('Hawk', 1, 2, 3, 4, BTIME2, UPGRADE2, roc, None)

drake = CreatureType('Drake', 2, 5, 3, 3, BTIME3, None, None, 'area')
drakeling = CreatureType('Drakeling', 2, 4, 3, 3, BTIME3, UPGRADE3, drake,
                         None)

flashflies = CreatureType('Flashflies', 3, 0, 3, 2, BTIME1, None, None,
                          'distractmore')
fireflies = CreatureType('Fireflies', 3, 0, 2, 2, BTIME1, UPGRADE1,
                         flashflies, 'distract')

wasps = CreatureType('Wasps', 4, 3, 4, 4, BTIME2, None, None, 'poison')
bees = CreatureType('Bees', 4, 2, 3, 3, BTIME2, UPGRADE2, wasps, None)

deathflies = CreatureType('Deathflies', 5, 4, 5, 3, BTIME3, None, None,
                          'fear')
giant_dragonflies = CreatureType('Giant dragonflies', 5, 3, 4, 3, BTIME3,
                                 UPGRADE3, deathflies, None)

def get_creature(ident):
    if ident == 0:
        return crow
    elif ident == 1:
        return hawk
    elif ident == 2:
        return drakeling
    elif ident == 3:
        return fireflies
    elif ident == 4:
        return bees
    elif ident == 5:
        return giant_dragonflies
    else:
        return None
