# As in the previous pyweeks, I feel obliged to say that the code is
# uncommented, ugly, and a total mess due to time constraints. :)
#   -- Tee

import sys
import math
import random
import pygame
from pygame.locals import *

import data
import util
import intro
import creatures
import enemies
import message
from locals import *

if pygame.mixer:
    global_music_set = True
else:
    global_music_set = False

class Menu:

    def __init__(self, screen):
        self.bg = pygame.image.load(data.filepath(IBGCITY)).convert()
        self.title = pygame.image.load(data.filepath(ITITLE)).convert_alpha()
        self.bg.blit(self.title, (235, 100))

        self.screen = screen

        self.font = pygame.font.Font(data.filepath(MAINFONT), 40)
        self.message = self.font.render('Click to Start', 1, FONTCOLOR)
        self.bg.blit(self.message, (265, 300))
        self.clock = pygame.time.Clock()

        self.start_music()

    def loop(self):
        self.screen.blit(self.bg, (0, 0))
        pygame.display.update()
        
        done = False

        while not done:
            for event in pygame.event.get():
                if event.type == QUIT:
                    sys.exit()
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        sys.exit()
                elif event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        intro.Intro(self.screen).loop()
                        done = True

            self.clock.tick(MAXFPS)

    def start_music(self):
        global global_music_set
        if len(sys.argv) > 1:
            if sys.argv[1] == '-s':
                global_music_set = False
        if global_music_set:
            try:
                pygame.mixer.init()
                pygame.mixer.music.load(data.filepath(MUSIC))
                pygame.mixer.music.play(-1)
            except:
                global_music_set = False
                print 'Warning: Unable to load music.'


class Game:

    def __init__(self, screen):
        self.bg = pygame.image.load(data.filepath(IBGCITY)).convert()
        self.foliage = pygame.image.load(data.
                                         filepath(IFOLIAGE)).convert_alpha()
        self.bg.blit(self.foliage, FOLIAGEPOS)
        self.tree = pygame.image.load(data.filepath(ITREE)).convert_alpha()
        self.bg.blit(self.tree, TREEPOS)        
        
        self.kinghuman = (pygame.image.load(data.filepath(IKINGHUMAN)).
                          convert_alpha())
        self.bg.blit(self.kinghuman, KINGHUMANPOS)

        self.font = pygame.font.Font(data.filepath(MAINFONT), 10)
        self.bg.blit(self.font.render('Next', 1, (255, 255, 255)),
                     (0, 40))
        self.bg.blit(self.font.render('Fruit', 1, (255, 255, 255)),
                     (0, 50))

        self.screen = screen

        self.lives = Lives(self)

        self.enemy_gen = EnemyGenerator(self.lives, self.win)

        self.nest_manager = NestManager(self.foliage, self.tree,
                                        self.enemy_gen)

        self.fruit_gen = FruitGenerator(self.nest_manager.crown,
                                        self.nest_manager.nests)

        self.clickables = []
        self.clickables.append(self.fruit_gen)
        self.clickables += self.nest_manager.clickables()

        self.message = pygame.sprite.RenderUpdates()
        self.message.add(message.global_msg)
        self.message.add(message.global_center_msg)
        self.message.add(message.global_human_msg)
        message.global_msg.write('Hello! Please read README.txt. I ' +
                                 'didn\'t have time to make a ' +
                                 'tutorial. I hope you enjoy my game!')
        message.global_human_msg.write('Me bring you ' + str(len(WAVES)) +
                                       ' waves of woolawoola-death!')

        self.mouse_status = None
        self.paused = False
        self.finished = False
        
        self.clock = pygame.time.Clock()

    def loop(self):
        global global_music_set
        
        self.screen.blit(self.bg, (0, 0))
        pygame.display.update()
        
        done = False

        while not done:
            for event in pygame.event.get():
                if event.type == QUIT:
                    sys.exit()
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        sys.exit()
                    elif event.key == K_p:
                        if not self.paused:
                            self.pause()
                            if global_music_set:
                                pygame.mixer.music.pause()
                        elif not self.finished:
                            self.unpause()
                            if global_music_set:
                                pygame.mixer.music.unpause()
                    elif event.key == K_m:
                        self.win()
                        if global_music_set:
                            if pygame.mixer.music.get_busy():
                                pygame.mixer.music.stop()
                            else:
                                pygame.mixer.music.play(-1)
                elif self.paused:
                    pass
                elif event.type == MOUSEBUTTONDOWN:
                    if event.button == 1:
                        click_sprites = []
                        for group in self.clickables:
                            gsprites = group.sprites()
                            gsprites.reverse()
                            click_sprites += gsprites
                        for clickable in click_sprites:
                            if util.hit(clickable.image, clickable.rect,
                                        event.pos) and clickable.clicked():
                                self.mouse_status = clickable
                                break
                elif event.type == MOUSEBUTTONUP:
                    if event.button == 1:
                        if self.mouse_status is not None:
                            self.mouse_status.release()
                            self.mouse_status = None
                elif event.type == MOUSEMOTION:
                    hoverables = self.nest_manager.crown.hoverables()
                    if hoverables is not None:
                        for hoverable in hoverables.sprites():
                            if util.hit(hoverable.image, hoverable.rect,
                                        event.pos):
                                hoverable.hover()

            if not self.paused:
                self.fruit_gen.clear(self.screen, self.bg)
                self.enemy_gen.clear(self.screen, self.bg)
                self.nest_manager.clear(self.screen, self.bg)            
                self.lives.clear(self.screen, self.bg)
            self.message.clear(self.screen, self.bg)

            if not self.paused:
                self.fruit_gen.update()
                self.enemy_gen.update()
                self.nest_manager.update()

            update_rects = []
            if not self.paused:
                update_rects += self.fruit_gen.draw(self.screen)
                update_rects += self.enemy_gen.draw(self.screen)
                update_rects += self.nest_manager.draw(self.screen)
                update_rects += self.lives.draw(self.screen)
            update_rects += self.message.draw(self.screen)

            pygame.display.update(update_rects)
            
            self.clock.tick(MAXFPS)

    def lose(self):
        message.global_center_msg.write('Awesome humans! I have fallen. ' +
                                        'I lose. :(')
        message.global_human_msg.write('Win! Want me shiny crown now!')
        self.finished = True
        self.paused = True

    def win(self):
        message.global_msg.write('Congratulations for winning and thanks ' +
                                 'for playing. I hope you had fun. :)')
        message.global_center_msg.write('Mwahaha! King Tree owns your ' +
                                        'world! I win! :)')
        message.global_human_msg.write('Nooo! King Human lose! Waaaah.')
        self.finished = True
        self.paused = True

    def pause(self):
        self.paused = True
        message.global_center_msg.write('Paused')
        pygame.display.update(self.message.draw(self.screen))

    def unpause(self):
        self.paused = False
        message.global_center_msg.clear_message()


class EnemyGenerator(pygame.sprite.RenderUpdates):

    def __init__(self, lives, win):
        pygame.sprite.RenderUpdates.__init__(self)

        self.current_wave = -1
        self.max_wave_timer = WAVE_TIMER
        self.wave_timer = self.max_wave_timer / 2
        self.max_timer = BETWEEN_TIMER
        self.timer = self.max_timer
        self.lives = lives
        self.win = win
        self.finished = False

        self.increment_wave()
        
    def get_current_list(self):
        self.current_list = WAVES[self.current_wave][:]
        self.choices = []
        for i in range(len(self.current_list)):
            if self.current_list[i] != 0:
                self.choices.append(i)

    def increment_wave(self):
        if self.current_wave < len(WAVES) - 1:
            self.current_wave += 1
        else:
            self.finished = True
        self.get_current_list()

    def update(self):
        pygame.sprite.RenderUpdates.update(self)

        if not self.finished:
            self.wave_timer -= 1
            if self.wave_timer <= 0:
                if self.wave_timer == 0:
                    text = random.choice(HUMANKINGWORDS)
                    if self.current_wave == len(WAVES) - 1:
                        text += '! Last strike!'
                    else:
                        text += '! Wave ' + str(self.current_wave + 1) + '!'
                    message.global_human_msg.write(text)
                self.timer -= 1
                if self.timer <= 0:
                    level = random.choice(self.choices)
                    self.current_list[level] -= 1
                    if self.current_list[level] == 0:
                        self.choices.remove(level)
                    self.generate(level)
                    self.timer = self.max_timer
                    if len(self.choices) == 0:
                        self.wave_timer = self.max_wave_timer
                        self.increment_wave()
        elif len(self.sprites()) == 0:
            self.win()

    def generate(self, level):
        path = random.choice(PATHS)
        enemy = Enemy(path, level, self.current_wave,self.lives)
        self.add(enemy)

    def clear(self, screen, bg):
        pygame.sprite.RenderUpdates.clear(self, screen, bg)
        for enemy in self.sprites():
            enemy.bar_sprite.clear(screen, bg)
            
    def draw(self, screen):
        update_rects = []
        update_rects += pygame.sprite.RenderUpdates.draw(self, screen)
        for enemy in self.sprites():
            update_rects += enemy.bar_sprite.draw(screen)
        return update_rects


class Enemy(pygame.sprite.Sprite):

    def __init__(self, path, ident, current_wave, lives):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(path[0])

        self.images_left = []
        for image in IENEMY[ident]:
            self.images_left.append(pygame.image.load(data.filepath(image)).
                                    convert_alpha())
        for i in range(len(self.images_left) - 1, 1, -1):
            self.images_left.append(self.images_left[i])
        self.images_right = []
        for image in self.images_left:
            self.images_right.append(pygame.transform.flip(image, True,
                                                           False))

        self.lives = lives
        self.path = path
        self.checkpoint = 1
        self.update_direction()
        
        self.animation = 0
        self.animation_delay_max = 4
        self.animation_delay = self.animation_delay_max

        self.image = self.images[self.animation]
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.enemy_type = enemies.get_enemy(ident)
        
        self.speed = ESPEEDS[self.enemy_type.speed]
        self.hp = EHPS[self.enemy_type.hp] * (1.0 + 0.06 * current_wave)

        self.finished = False
        self.dead = False

        self.bar = Bar([self.rect.left, self.rect.top - 10], self.hp,
                       self.image.get_width(), (192, 0, 0), True, 5)
        self.bar_sprite = pygame.sprite.RenderUpdates()
        self.bar_sprite.add(self.bar)

        self.distracted = False
        self.distractedmore = False
        self.poison = self.hp / 4
        self.poisoned = False
        self.fear = False

    def lose_hp(self, hp):
        self.hp -= hp
        if self.hp <= 0:
            self.kill()
            self.dead = True

    def special(self, special):
        if special is not None:
            if special == 'distract':
                self.distracted = True
            elif special == 'distractmore':
                self.distractedmore = True
            elif special == 'poison':
                self.poison = True
                self.distracted = True
            elif special == 'fear':
                self.fear = True

    def unspecial(self, special):
        if special is not None:
            if special == 'distract':
                self.distracted = False
            elif special == 'distractmore':
                self.distractedmore = False
            elif special == 'fear':
                self.fear = False
            elif special == 'poison':
                self.distracted = False
                
    def update_direction(self):
        if self.checkpoint < len(self.path):
            if (self.path[self.checkpoint-1][0] <=
                self.path[self.checkpoint][0]):
                self.images = self.images_right
            else:
                self.images = self.images_left

    def update_animation(self):
        self.animation_delay -= 1
        if self.animation_delay == 0:
            self.animation_delay = self.animation_delay_max
            self.image = self.images[self.animation]
            self.rect = self.image.get_rect()
            self.rect.center = self.pos
            self.animation = (self.animation + 1) % len(self.images)
        
    def update(self):
        self.update_animation()
        self.bar.update_pos([self.rect.left, self.rect.top - 10])
        self.bar.update_timer(self.hp)
        
        if self.pos == list(self.path[self.checkpoint]):
            if self.checkpoint == len(self.path) - 1:
                self.finished = True
                self.lives.lose_life()
                self.kill()
            else:
                self.checkpoint += 1
                self.update_direction()
        
        if not self.finished:
            if self.poisoned and self.poison > 0:
                self.poison -= 1
                self.hp -= 1
            real_speed = self.speed
            if self.fear:
                real_speed *= 0.25
            elif self.distractedmore:
                real_speed *= 0.5
            elif self.distracted:
                real_speed *= 0.75
            self.pos = util.go_towards(self.pos, self.path[self.checkpoint],
                                       real_speed)
            self.rect.center = self.pos

       
class FruitGenerator(pygame.sprite.RenderUpdates):

    def __init__(self, crown, nests):
        pygame.sprite.RenderUpdates.__init__(self)
        
        self.timer = random.randint(FRUITINT1, FRUITINT2)
        self.crown = crown
        self.nests = nests
        self.fruit_bar = Bar(FRUITBARPOS, self.timer, 30, (0, 196, 196))
        self.add(self.fruit_bar)

    def generate(self):
        pos = [random.randint(130, 670), random.randint(160, 460)]
        fruit = Fruit(pos, self.crown, self.nests)
        self.add(fruit)

    def update(self):
        pygame.sprite.RenderUpdates.update(self)
        if not self.crown.busy():
            self.timer -= 1
            self.fruit_bar.update_timer(self.timer)
            if self.timer <= 0:
                self.timer = random.randint(FRUITINT1, FRUITINT2)
                self.generate()


class Bar(pygame.sprite.Sprite):

    def __init__(self, pos, timer, length, color, horizontal=False,
                 thickness=10):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)
        self.length = length
        self.tmax = timer
        self.color = color
        self.horizontal = horizontal
        self.thickness = thickness

        self.update_timer(timer)

    def update_timer(self, timer):
        size = int(float(timer) / self.tmax * self.length)
        if self.horizontal:
            self.image = pygame.Surface((size, self.thickness))
        else:
            self.image = pygame.Surface((self.thickness, size))
        self.image.fill(self.color)
        self.rect = self.image.get_rect()
        self.rect.topleft = self.pos

    def update_pos(self, pos):
        self.pos = pos


class Fruit(pygame.sprite.Sprite):

    def __init__(self, pos, crown, nests):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)

        self.real_image = (pygame.image.load(data.filepath(IFRUIT1)).
                           convert_alpha())
        self.image = pygame.Surface(self.real_image.get_size())
        self.image.set_colorkey((0, 0, 0))
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.dragged = False
        self.fixed = True
        self.swallowing = False

        self.vel = 0

        self.total_timer = 25
        self.timer = self.total_timer
        self.step = [0, 0]
        self.step[0] = 1.0 / self.timer * self.real_image.get_width()
        self.step[1] = 1.0 / self.timer * self.real_image.get_height()

        self.crown = crown
        self.nests = nests

    def clicked(self):
        if not self.swallowing:
            self.drag()
            return True
        return False

    def drag(self):
        self.vel = 0
        self.fixed = False
        self.dragged = True

    def release(self):
        self.dragged = False

    def swallow(self):
        if not self.swallowing:
            self.swallowing = True
            self.timer = 1

    def update(self):
        if self.timer > 0 and self.timer <= self.total_timer:
            if self.swallowing:
                self.vel = 0.5
                self.timer += 1
            else:
                self.timer -= 1
            if self.timer == 0:
                self.image = self.real_image
                self.rect = self.image.get_rect()
                self.rect.center = self.pos
            elif self.timer > self.total_timer:
                self.kill()
            else:
                self.image = pygame.transform.scale(self.real_image,
                        (int(self.step[0] * (self.total_timer - self.timer)),
                         int(self.step[1] * (self.total_timer - self.timer))))
                self.rect = self.image.get_rect()
                self.rect.center = self.pos
        if self.dragged:
            self.pos = list(pygame.mouse.get_pos())
            self.rect.center = self.pos
        elif not self.fixed:
            if not self.swallowing:
                rect_drop_left = Rect(FRUITDROPLEFT[0], FRUITDROPLEFT[1])
                rect_drop_right = Rect(FRUITDROPRIGHT[0], FRUITDROPRIGHT[1])
                if (rect_drop_left.collidepoint(self.pos) and
                    self.crown.accept_bird_fruit()):
                    self.crown.add_bird_fruit()
                    self.swallow()
                elif (rect_drop_right.collidepoint(self.pos) and
                    self.crown.accept_insect_fruit()):
                    self.crown.add_insect_fruit()
                    self.swallow()
                else:
                    for nest in self.nests.sprites():
                        if (util.hit(nest.image, nest.rect, self.pos) and
                            not nest.is_upgraded()):
                            nest.add_fruit()
                            self.swallow()
                            break
            if self.pos[1] >= HEIGHT - 30:
                self.pos[1] = HEIGHT - 30
                self.vel = 0
            else:
                self.vel += 0.5
                self.pos[1] += self.vel
            self.rect.center = self.pos


class NestManager:

    def __init__(self, foliage, tree, enemies):
        self.foliage = foliage
        self.tree = tree
        self.enemies = enemies
        self.unborn_nests = pygame.sprite.RenderUpdates()
        self.nests = pygame.sprite.RenderUpdates()
        self.crown = Crown(CROWNPOS, self.create_unborn_nest)
        self.dragged = None
        self.range_sprite = pygame.sprite.RenderUpdates()

    def ok_to_release(self, pos):
        rect_foliage = self.foliage.get_rect()
        rect_foliage.topleft = FOLIAGEPOS
        if not util.hit(self.foliage, rect_foliage, pos):
            return False
        rect_tree = self.tree.get_rect()
        rect_tree.topleft = TREEPOS
        if util.hit(self.tree, rect_tree, pos):
            return False
        for nest in self.nests:
            if util.hit(nest.image, nest.rect, pos):
                return False
        return True

    def being_dragged(self, dragged):
        self.dragged = dragged
        self.range_sprite.add(AttackRange(dragged.pos,
                                          RANGES[dragged.creature.range]))
        
    def release_unborn(self, unborn):
        self.range_sprite.empty()
        self.nests.add(Nest(unborn.pos, unborn.creature, self.enemies))
        message.global_msg.write(unborn.creature.name + ' nest built!')
        self.unborn_nests.remove(unborn)

    def create_unborn_nest(self, pos, id):
        self.unborn_nests.add(UnbornNest(pos, creatures.get_creature(id),
                                         self))

    def done_building(self):
        self.crown.done_building()

    def clickables(self):
        return [self.unborn_nests, self.crown.clickables()]

    def clear(self, screen, bg):
        self.crown.clear(screen, bg)
        self.range_sprite.clear(screen, bg)
        self.unborn_nests.clear(screen, bg)
        for nest in self.nests.sprites():
            nest.creatures.clear(screen, bg)
        self.nests.clear(screen, bg)

    def update(self):
        self.crown.update()
        self.range_sprite.update()
        self.unborn_nests.update()
        for nest in self.nests.sprites():
            nest.creatures.update()
        self.nests.update()

    def draw(self, screen):
        update_rects = []
        update_rects += self.crown.draw(screen)
        update_rects += self.range_sprite.draw(screen)
        update_rects += self.unborn_nests.draw(screen)
        for nest in self.nests.sprites():
            update_rects += nest.creatures.draw(screen)
        update_rects += self.nests.draw(screen)
        return update_rects


class UnbornNest(pygame.sprite.Sprite):

    def __init__(self, pos, creature, nest_manager):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)

        self.creature = creature
        
        self.real_image = (pygame.image.load(data.filepath(
            self.creature.image_unborn)).convert_alpha())

        self.bcolor = self.real_image.get_at((self.real_image.get_width() / 2,
                                            self.real_image.get_height() / 2))
        self.image = pygame.Surface(self.real_image.get_size())
        self.image.fill((0, 255, 0))
        self.image.set_colorkey((0, 255, 0))
        self.elrect_pos = [self.real_image.get_width() / 2,
                           self.real_image.get_height() / 2]
        self.elrect_size = [self.elrect_pos[0] - self.real_image.get_width(),
                            self.elrect_pos[1] - self.real_image.get_height()]
        elrect = Rect((0, 0), self.real_image.get_size())
        pygame.draw.ellipse(self.image, self.bcolor, elrect)
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.born_timer = self.creature.build_time
        self.step_timer = [1.0 / self.born_timer * self.elrect_pos[0],
                           1.0 / self.born_timer * self.elrect_pos[1]]

        self.dragged = False
        self.nest_manager = nest_manager

    def clicked(self):
        if self.born_timer == 0:
            self.drag()
            return True
        return False

    def drag(self):
        self.nest_manager.being_dragged(self)
        self.dragged = True

    def release(self):
        if self.nest_manager.ok_to_release(self.pos):
            self.dragged = False
            self.nest_manager.release_unborn(self)
        
    def update(self):
        if self.born_timer > 0:
            self.image = pygame.Surface(self.real_image.get_size())
            self.image.fill((0, 255, 0))
            self.image.set_colorkey((0, 255, 0))
            self.elrect_pos[0] -= self.step_timer[0]
            self.elrect_pos[1] -= self.step_timer[1]
            self.elrect_size = [self.real_image.get_width() -
                                self.elrect_pos[0],
                                self.real_image.get_height() -
                                self.elrect_pos[1]]
            elrect = Rect(self.elrect_pos, self.elrect_size)
            pygame.draw.ellipse(self.image, self.bcolor, elrect)
            self.born_timer -= 1
            if self.born_timer == 0:
                self.image = self.real_image
                self.nest_manager.done_building()
        elif self.dragged:
            self.pos = pygame.mouse.get_pos()
            self.rect.center = self.pos


class AttackRange(pygame.sprite.Sprite):

    def __init__(self, pos, range):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)

        self.image = pygame.Surface((range * 2, range * 2))
        self.image.set_colorkey((0, 0, 0))
        pygame.draw.circle(self.image, (64, 0, 0), (range, range),
                           range - 1, 1)
        self.rect = self.image.get_rect()
        self.rect.center = pos

    def update(self):
        self.rect.center = pygame.mouse.get_pos()
        

class Nest(pygame.sprite.Sprite):

    def __init__(self, pos, creature, enemies):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)

        self.creature_type = creature
        self.enemies = enemies

        self.image = (pygame.image.load(data.filepath(
            self.creature_type.image_nest)).convert_alpha())
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.creatures = pygame.sprite.RenderUpdates()
        self.creatures.add(Creature(self.creature_type, self, self.enemies))

        self.fruit = 0
        self.upgraded = False

    def add_fruit(self):
        self.fruit += 1
        if self.fruit == self.creature_type.toupgrade:
            self.upgraded = True
            text = (self.creature_type.name + ' upgraded to ' +
                    self.creature_type.upgrade.name + '! ')
            self.creature_type = self.creature_type.upgrade
            text += self.creature_type.get_description()
            message.global_msg.write(text)
            creature = self.creatures.sprites()[0]
            self.creatures.empty()
            self.creatures.add(Creature(self.creature_type, self,
                                        self.enemies, creature.pos))
            self.upgrade_image = (pygame.image.load(data.filepath(
                IUPGRADE)).convert_alpha())
            self.image.blit(self.upgrade_image, (0, self.image.get_height() -
                                                 10))

    def is_upgraded(self):
        return self.upgraded


class Creature(pygame.sprite.Sprite):

    IDLE = 1
    FLYING = 2
    ATTACKING = 3

    def __init__(self, creature_type, nest, enemies, pos = None):
        pygame.sprite.Sprite.__init__(self)

        self.creature_type = creature_type
        self.nest = nest
        self.enemies = enemies

        if pos is None:
            self.pos = [0, 0]
            if self.nest.pos[0] < WIDTH / 2:
                self.pos[0] = -20
            else:
                self.pos[0] = WIDTH + 20
            self.pos[1] = random.randint(0, 3 * HEIGHT / 4)
        else:
            self.pos = list(pos)

        self.image_idle_left = (pygame.image.load(data.filepath(
            ICREATUREIDLE[self.creature_type.id])).convert_alpha())
        self.image_idle_right = pygame.transform.flip(self.image_idle_left,
                                                      True, False)

        self.images_flying_left = []
        for image in ICREATUREFLYING[self.creature_type.id]:
            self.images_flying_left.append(pygame.image.load(
                data.filepath(image)).convert_alpha())
        for i in range(len(self.images_flying_left) - 1, 1, -1):
            self.images_flying_left.append(self.images_flying_left[i])
        self.images_flying_right = []
        for image in self.images_flying_left:
            self.images_flying_right.append(pygame.transform.flip(image, True,
                                                                  False))

        self.images_flying = self.images_flying_left
        self.image_idle = self.image_idle_left
        self.left = True
        
        self.image = self.image_idle_left
        self.rect = self.image.get_rect()
        self.rect.center = self.pos
        
        self.animation = 0
        self.animation_delay_max = 4
        self.animation_delay = self.animation_delay_max
        
        self.attack = ATTACKS[self.creature_type.attack]
        self.speed = SPEEDS[self.creature_type.speed]
        self.range = RANGES[self.creature_type.range]

        self.target_attack = None
        self.target_move = None

        self.nest_pos = [self.nest.pos[0], self.nest.pos[1] - 15]

        self.fly(self.nest_pos)

    def update_direction(self):
        if ((self.status == self.FLYING and
             self.pos[0] <= self.target_move[0]) or
            (self.status == self.ATTACKING and
             self.pos[0] <= self.target_attack.pos[0])):
            self.left = False
            self.images_flying = self.images_flying_right
            self.image_idle = self.image_idle_right
        else:
            self.left = True
            self.images_flying = self.images_flying_left
            self.image_idle = self.image_idle_left

    def update_flying_animation(self):
        self.animation_delay -= 1
        if self.animation_delay == 0:
            self.animation_delay = self.animation_delay_max
            self.image = self.images_flying[self.animation]
            self.rect = self.image.get_rect()
            self.rect.center = self.pos
            self.animation = (self.animation + 1) % len(self.images_flying)
            
    def idle(self):
        self.status = self.IDLE
        self.target_attack = None
        self.target_move = None
        self.image = self.image_idle

    def fly(self, target):
        self.status = self.FLYING
        self.target_move = target
        self.target_attack = None
        self.update_direction()

    def go_attack(self, target):
        self.status = self.ATTACKING
        self.target_attack = target
        self.target_move = None
        self.update_direction()
        
    def update(self):
        if self.status == self.FLYING or self.status == self.IDLE:
            for enemy in self.enemies.sprites():
                if util.distance_comp(enemy.pos, self.nest_pos, self.range):
                    if self.creature_type.special is not None:
                        if (self.creature_type.special.
                            startswith('distract') and
                            enemy.distracted or enemy.distractedmore):
                            continue
                    self.go_attack(enemy)
        if self.status == self.FLYING:
            self.update_flying_animation()
            self.pos = util.go_towards(self.pos, self.target_move, self.speed)
            if self.pos == self.nest_pos:
                self.idle()
        elif self.status == self.ATTACKING:
            self.update_flying_animation()
            if not util.distance_comp(self.target_attack.pos, self.nest_pos,
                                      self.range) or self.target_attack.dead:
                self.target_attack.unspecial(self.creature_type.special)
                self.fly(self.nest_pos)
            else:
                if self.target_attack.rect.colliderect(self.rect):
                    self.target_attack.lose_hp(self.attack)
                    self.target_attack.special(self.creature_type.special)
                if self.target_attack.special == 'area':
                    for enemy in self.enemies.sprites():
                        if enemy.rect.colliderect(self.rect):
                            self.target_attack.lose_hp(self.attack)
                self.pos = util.go_towards(self.pos, self.target_attack.pos,
                                           self.speed)
            
        self.rect.center = self.pos


class Crown(pygame.sprite.Sprite):

    def __init__(self, pos, create_nest):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)

        self.image = pygame.image.load(data.filepath(ICROWN)).convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.bird_fruits = 0
        self.insect_fruits = 0
        self.bird_level = 1
        self.insect_level = 1

        self.building = -1

        self.update_rects = []
        
        self.create_nest = create_nest
        
        self.leaves = pygame.sprite.OrderedUpdates()
        self.leaves.add(Leaf(LEFTLEAFPOS, LEFTLEAFEND, 0, self))
        self.leaves.add(Leaf(RIGHTLEAFPOS, RIGHTLEAFEND, 3, self))
        self.fix_leaves_order()

    def add_bird_fruit(self):
        self.bird_fruits += 1
        if self.bird_level == 1 and self.bird_fruits == TOLEVEL2:
            self.bird_level = 2
            self.leaves.add(Leaf(LEFTLEAFPOS, LEFTLEAFEND * 2, 1, self))
            self.fix_leaves_order()
        elif self.bird_level == 2 and self.bird_fruits == TOLEVEL3:
            self.bird_level = 3
            self.leaves.add(Leaf(LEFTLEAFPOS, LEFTLEAFEND * 3, 2, self))
            self.fix_leaves_order()

    def accept_bird_fruit(self):
        return (self.bird_level < 3)
            
    def add_insect_fruit(self):
        self.insect_fruits += 1
        if self.insect_level == 1 and self.insect_fruits == TOLEVEL2:
            self.insect_level = 2
            self.leaves.add(Leaf(RIGHTLEAFPOS, RIGHTLEAFEND * 2, 4, self))
            self.fix_leaves_order()
        elif self.insect_level == 2 and self.insect_fruits == TOLEVEL3:
            self.insect_level = 3
            self.leaves.add(Leaf(RIGHTLEAFPOS, RIGHTLEAFEND * 3, 5, self))
            self.fix_leaves_order()

    def accept_insect_fruit(self):
        return (self.insect_level < 3)
            
    def fix_leaves_order(self):
        sprites = self.leaves.sprites()
        sprites.insert(0, sprites.pop())
        self.leaves.empty()
        self.leaves.add(sprites)

    def toggle_leaves(self):
        for leaf in self.leaves.sprites():
            leaf.reverse()

    def build_nest(self, ident):
        if not self.busy():
            message.global_msg.write('Building ' +
                                     creatures.get_creature(ident).name +
                                     ' nest...')
            self.toggle_leaves()
            self.building = ident
            if self.building < 3:
                self.create_nest(BUILDLEFTPOS, ident)
            else:
                self.create_nest(BUILDRIGHTPOS, ident)

    def done_building(self):
        self.toggle_leaves()
        self.building = -1

    def clickables(self):
        return self.leaves

    def hoverables(self):
        if self.busy():
            return None
        return self.leaves

    def busy(self):
        return (self.building != -1)

    def clear(self, screen, bg):
        self.leaves.clear(screen, bg)
        self.update_rects = []
        self.update_rects.append(Rect(self.rect))
        screen.blit(bg, self.rect, self.rect)

    def update(self):
        self.leaves.update()

    def draw(self, screen):
        self.update_rects += self.leaves.draw(screen)
        screen.blit(self.image, self.rect)
        self.update_rects.append(Rect(self.rect))
        return self.update_rects


class Leaf(pygame.sprite.Sprite):

    def __init__(self, pos, end, ident, crown):
        pygame.sprite.Sprite.__init__(self)

        self.pos = list(pos)
        self.end = end
        self.endpos = pos[0] + end
        
        self.image = (pygame.image.load(data.filepath(ILEAVES[ident])).
                      convert_alpha())
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        self.speed = self.end / 20

        self.id = ident

        self.crown = crown

        self.stopped = False

    def clicked(self):
        if not self.crown.busy():
            self.crown.build_nest(self.id)
            return True
        return False

    def release(self):
        pass

    def hover(self):
        creature = creatures.get_creature(self.id)
        text = 'Build ' + creature.name + ' - ' + creature.get_description()
        message.global_msg.write(text)

    def reverse(self):
        self.speed = -self.speed
        self.end = -self.end
        self.endpos = self.endpos + self.end
        self.stopped = False

    def update(self):
        if not self.stopped:
            self.pos[0] += self.speed
            if ((self.end <= 0 and self.pos[0] <= self.endpos) or
                (self.end >= 0 and self.pos[0] >= self.endpos)):
                self.pos[0] = self.endpos
                self.stopped = True
            self.rect.center = self.pos


class StatusMessage(pygame.sprite.Sprite):

    def __init__(self):
        pygame.sprite.Sprite.__init__(self)

        self.pos = [WIDTH, 0]
        self.write('')

    def write(self, message):
        self.message = message
        self.font = pygame.font.Font(data.filepath(MAINFONT), 40)
        self.image = self.font.render(self.message, 1, FONTCOLOR)
        self.rect = self.image.get_rect()
        self.rect.topright = self.pos


class Lives(pygame.sprite.RenderUpdates):

    def __init__(self, game):
        pygame.sprite.RenderUpdates.__init__(self)

        self.game = game

        self.new_life((385, 110))
        self.new_life((390, 115))
        self.new_life((393, 121))
        self.new_life((397, 120))
        self.new_life((400, 110))
        self.new_life((405, 114))
        self.new_life((411, 120))
        self.new_life((410, 112))
        self.new_life((413, 112))
        self.new_life((421, 115))
        
    def new_life(self, pos):
        life = pygame.sprite.Sprite()
        life.image = pygame.image.load(data.filepath(ILIFE)).convert_alpha()
        life.rect = life.image.get_rect()
        life.rect.center = pos
        self.add(life)

    def lose_life(self):
        for sprite in self.sprites():
            self.remove(sprite)
            break
        if len(self.sprites()) == 0:
            self.game.lose()
