MAXFPS = 50

WIDTH = 800
HEIGHT = 600

MUSIC = 'rainforrest.ogg'

IICON = 'icon.png'
IBGCITY = 'bg-city.png'
IFRUIT1 = 'fruit1.png'
ITITLE = 'title.png'
IFOLIAGE = 'foliage.png'
ITREE = 'tree.png'
ICROWN = 'crown.png'
IUPGRADE = 'upgrade.png'
ILIFE = 'life.png'
IKINGHUMAN = 'kinghuman.png'
IUNBORN = []
for i in range(6):
    IUNBORN.append('unborn' + str(i + 1) + '.png')
INEST = []
for i in range(6):
    INEST.append('nest' + str(i + 1) + '.png')
ILEAVES = []
for i in range(6):
    ILEAVES.append('leaf' + str(i + 1) + '.png')
ICREATUREIDLE = []
ICREATUREFLYING = []
for i in range(6):
    ICREATUREIDLE.append('creature' + str(i + 1) + '-idle.png')
    ICREATUREFLYING.append(['creature' + str(i + 1) + '-fly1.png',
                            'creature' + str(i + 1) + '-fly2.png',
                            'creature' + str(i + 1) + '-fly3.png'])
IENEMY = []
IENEMY.append(['enemy1-1.png', 'enemy1-1.png', 'enemy1-2.png', 'enemy1-3.png',
               'enemy1-4.png', 'enemy1-5.png'])
IENEMY.append(['enemy2-1.png', 'enemy2-2.png', 'enemy2-3.png',
               'enemy2-4.png', 'enemy2-5.png'])
IENEMY.append(['enemy3-1.png', 'enemy3-2.png', 'enemy3-3.png'])
IENEMY.append(['enemy4-1.png', 'enemy4-2.png'])
IENEMY.append(['enemy5-1.png', 'enemy5-2.png'])
IENEMY.append(['enemy6-1.png', 'enemy6-2.png'])

MAINFONT = 'domisc__.ttf'
FONTCOLOR = (255, 255, 255)

PATH0 = [(-10, 566), (197, 566), (718, 347), (410, 313), (166, 330),
         (117, 301), (206, 211), (221, 179), (399, 81)]
PATH1 = [(810, 566), (555, 566), (201, 410), (312, 331), (496, 278),
         (707, 223), (595, 186), (463, 164), (384, 103)]
PATHS = [PATH0, PATH1]

# Fruits to new creatures
TOLEVEL2 = 5
TOLEVEL3 = 15

# Fruits to upgrade creatures
UPGRADE1 = 2
UPGRADE2 = 4
UPGRADE3 = 8

# Time to build (in ticks)
BTIME1 = 350
BTIME2 = 700
BTIME3 = 1200

FOLIAGEPOS = (20, 75)
TREEPOS = (110, 105)
CROWNPOS = (400, 50)
FRUITBARPOS = (10, 10)
KINGHUMANPOS = (WIDTH - 70, HEIGHT - 70)

LEFTLEAFPOS = (CROWNPOS[0] - 50, CROWNPOS[1] + 40)
LEFTLEAFEND = -28

RIGHTLEAFPOS = (CROWNPOS[0] + 50, CROWNPOS[1] + 40)
RIGHTLEAFEND = 28

BUILDLEFTPOS = (LEFTLEAFPOS[0], LEFTLEAFPOS[1] - 50)
BUILDRIGHTPOS = (RIGHTLEAFPOS[0], RIGHTLEAFPOS[1] - 50)

# Interval between new fruits
FRUITINT1 = FRUITINT2 = 300

ATTACKS = [0, 1, 2, 4, 6, 10]
SPEEDS = [0, 1, 2, 4, 6, 8]
RANGES = [0, 50, 90, 130, 170, 300]

EHPS = [0, 150, 600, 1400]
ESPEEDS = [0, 0.75, 1.5, 2.5]

FRUITDROPLEFT = [(306, 54), (90, 64)]
FRUITDROPRIGHT = [(398, 54), (90, 64)]

WAVES = [[3, 0, 0, 0, 0, 0],
         [8, 0, 0, 0, 0, 0],
         [15, 0, 0, 0, 0, 0],
         [10, 5, 0, 0, 0, 0],
         [15, 10, 0, 0, 0, 0],
         [0, 0, 10, 0, 0, 0],
         [5, 10, 10, 0, 0, 0],
         [0, 0, 0, 5, 0, 0],
         [10, 10, 10, 5, 0, 0],
         [0, 0, 10, 15, 0, 0],
         [0, 0, 30, 0, 0, 0],
         [0, 0, 0, 30, 0, 0],
         [0, 0, 0, 0, 10, 0],
         [0, 0, 10, 10, 10, 0],
         [0, 0, 15, 15, 10, 0],
         [0, 0, 0, 20, 20, 0],
         [0, 0, 0, 0, 0, 10],
         [0, 0, 0, 0, 10, 10],
         [0, 0, 20, 0, 0, 20],
         [10, 10, 10, 10, 10, 20]]

WAVE_TIMER = 1200
BETWEEN_TIMER = 50

HUMANKINGWORDS = ['Grubberdat', 'Pluskarpa', 'Bubudash', 'Maloo',
                  'Waaat', 'Frooba', 'Moolasha', 'Blabberblu',
                  'Frankermoo', 'Evante', 'Pulamoon', 'Zakatoo',
                  'Alershash', 'Purtashush', 'Frackerbas', 'Quokaku',
                  'Flumbashish', 'Pobbishoo', 'Malakatapoo', 'Hundashash',
                  'Flipflopfloo', 'Troombadoon', 'Ashloshwoosh',
                  'Meeza', 'Zeimizan', 'Peepapoo', 'Kalambadarush',
                  'Frendufoo', 'Swembadaroo', 'Kakakakaboo', 'Bookakakaka',
                  'Grogrugroo', 'Erbablesh', 'Bleshblashbloo', 'Frakdiboo',
                  'Mubbadum', 'Primdalay', 'Combishoo', 'Waaaaaa', 'Bloooo',
                  'Fuuuushhhh', 'Bibibifomfoom', 'Sepoopookadoomba',
                  'Mashuu', 'Yammamaa']
