import pygame
from pygame.locals import *

import data
from locals import *

class StatusMessage(pygame.sprite.Sprite):

    STATUS = 0
    CENTER = 1
    HUMAN = 2

    def __init__(self, size=14, position=STATUS):
        pygame.sprite.Sprite.__init__(self)

        pygame.font.init()
        self.pos = [WIDTH, 0]
        self.center_pos = [WIDTH / 2, HEIGHT / 2]
        self.human_pos = [WIDTH, HEIGHT - 80]
        self.size = size
        self.position = position
        self.write('')

    def write(self, message):
        self.message = message
        self.font = pygame.font.Font(data.filepath(MAINFONT), self.size)
        self.image = self.font.render(self.message, 1, (255, 255, 255))
        self.rect = self.image.get_rect()
        if self.position == self.CENTER:
            self.rect.center = self.center_pos
        elif self.position == self.HUMAN:
            self.rect.bottomright = self.human_pos
        else:
            self.rect.topright = self.pos

    def clear_message(self):
        self.write('')
        

global_msg = StatusMessage()
global_center_msg = StatusMessage(30, 1)
global_human_msg = StatusMessage(18, 2)
