import math
import pygame

def hit(image, rect, pos):
    return (rect.collidepoint(pos) and not
            image.get_at([int(pos[0] - rect.topleft[0]),
                          int(pos[1] - rect.topleft[1])])[3] == 0)

def go_towards(pos_orig, target, speed):
    pos = pos_orig[:]
    dx = pos[0] - target[0]
    dy = pos[1] - target[1]
    dist = math.hypot(dx, dy)
    if dist <= speed:
        pos[0] = target[0]
        pos[1] = target[1]
    else:
        pos[0] -= speed * dx / dist
        pos[1] -= speed * dy / dist
    return pos

def distance_comp(pos1, pos2, dist):
    dx = pos1[0] - pos2[0]
    dy = pos1[1] - pos2[1]
    return (dx * dx + dy * dy <= dist * dist)
